var feld_distance = new Int32Array(256 * 256);
var feld_distance_done = new Int32Array(256 * 256);
var feld_distance_done_val = 0;
var pieces = new Int32Array(256 * 256);

var dirs = new Array("up", "right", "down", "left", "illegal");
var dir = 2;

var x = 128;
var y = 128;
var i = 0;

var distance = new Array(256, 1, -256, -1);

var pos = x + y * 256;
var new_pos = pos;

var first = true;

var x_min = x;
var x_max = x;
var y_min = y;
var y_max = y;

var width = false;
var height = false;

var borderpos = 0;
var borderpos2 = 0;

var crosssteps = 0;

var done;
var id;

var finish_states = false;

var theevent;

var follow_dir_err = new Int32Array(4);

var cr_move = 0;
var cr_moves = [];
var cr_first = true;

var follower_move = 0;
var follower_first = true;
var allowed_pieces = 1;
var old_follower_state = 0;
var follower_max_own = 25;
var follow_repeat = 1;

var lookup_stack = new Int32Array(100 * 100);
var lookup_read = 0;
var lookup_write = 0;

var way_to_space = new Int32Array(100 * 100);
var way_to_space_steps;
var pos_for_space;

var actual_pos;
var check_pos;

var move_done;

var gobackdir;
var gobackcounter;
var gobackstate;
var cleardir;
var clearpos;
var clearcounter;

var totalsteps = 0;

var trapitokcounter = 0;
var trapitstartpos = -1;
var spiralcounter = 0;

var follower_r = 1;
var follower_l = 3;

/*STOP*/

var cr = [];

store_done = function(event)
{
	theevent = event;
	done = event.data.done;

	if (done)
	{		
		if (pieces[new_pos] == 1)
		{
			own_steps++;
		}
		else
		{
			pieces[new_pos] = 1;
			own_steps = 0;
		}

		pos = new_pos;		
	}
	else
	{
		pieces[new_pos] = 2;
	}
}

store_width = function()
{
	x = pos & 255;

	if (x < x_min)
	{
		x_min = x;
	}
	if (x > x_max)
	{
		x_max = x;
	}
	if ((x_max - x_min) == 99)
	{
		width = true;
		
		borderpos = x_min - 1;
		borderpos2 = x_max + 1;
		
		for (i = 0; i < 256; i++)
		{
			pieces[borderpos + i * 256] = 2;
			pieces[borderpos2 + i * 256] = 2;
		}
	}
}

store_height = function()
{
	y = pos >> 8;

	if (y < y_min)
	{
		y_min = y;
	}
	if (y > y_max)
	{
		y_max = y;
	}
	if ((y_max - y_min) == 99)
	{
		height = true;

		borderpos = (y_min - 1) * 256;
		borderpos2 = (y_max + 1) * 256;
		
		for (i = 0; i < 256; i++)
		{
			pieces[borderpos + i] = 2;
			pieces[borderpos2 + i] = 2;
		}
	}
}

do_move = function()
{
	totalsteps++;
    new_pos = pos + distance[dir];
	// postMessage({id: theevent.data.id,direction: dirs[dir], pieces: this.pieces});    
	postMessage({id: theevent.data.id,direction: dirs[dir]});    
}

cr[1] = function()
{
	if (!done)
	{
		cr_moves[1] = cr_move;
		cr_move = 0;
		cr_state = cr[2];
		dir = 1;
	}
}

cr[2] = function()
{
	if (!done || cr_move == 2)
	{
		cr_moves[2] = cr_move;
		cr_move = 0;
		cr_state = cr[3];
		dir = 0;
	}
}

cr[3] = function()
{
	if (!done || cr_move == 50)
	{
		cr_moves[3] = cr_move;
		cr_move = 0;
		cr_state = cr[4];
		dir = 1;
	}
}

cr[4] = function()
{
	if (!done)
	{
		cr_moves[4] = cr_move;
		cr_move = 0;
		cr_state = cr[5];
		dir = 0;
	}
	return true;
}

cr[5] = function()
{
	if (!done || cr_move == 2)
	{
		if (cr_move == 0)
		{
			dir = 2;
			onmessage = onmessage_follower;
		}
		else
		{
			cr_moves[5] = cr_move;
			cr_move = 0;
			cr_state = cr[6];
			dir = 3;
		}
	}
}

cr[6] = function()
{
	if (!done || cr_move == cr_moves[4])
	{
		cr_moves[6] = cr_move;
		cr_move = 0;
		if (cr_moves[1] > cr_moves[3])
		{
			cr_state = cr[7];
			dir = 0;
		}
		else
		{
			cr_state = cr[8];
			dir = 3;
		}
	}
	return true;
}

cr[7] = function()
{
	if (!done || cr_move == (cr_moves[1] - cr_moves[3]))
	{
		cr_moves[7] = cr_move;
		cr_move = 0;
		cr_state = cr[8];
		dir = 3;
	}
}

cr[8] = function()
{
	if (!done)
	{
		cr_moves[8] = cr_move;
		cr_move = 0;
		cr_state = cr[100];
		dir = 3;
		onmessage = onmessage_follower;
	}
}

var cr_state = cr[1];

onmessage_crosser = function (event) {

	store_done(event);

	if (done)
	{
		cr_move++;
		
		if (!width)
		{
			store_width();
		}
		
		if (!height)
		{
			store_height();
		}
	}

	cr_state();
	do_move();
}

onmessage_follower = function (event)
{
	store_done(event);

	if (done)
	{
		if (follow_dir_err[dir] > 1)
		{
			follow_dir_err[dir] = 0;
			dir = (dir + follower_l) & 3;
			onmessage = onmessage_straight;
			do_move();
			return;
		}
		follower_move++;
		
		if (own_steps > follower_max_own)
		{
			if (finder())
			{
				onmessage = onmessage_walk_to_space;
			}
			else
			{
				onmessage = onmessage_do_rnd;
			}
			onmessage(theevent);
			return;
		}
		
		if (!width)
		{
			store_width();
		}
		
		if (!height)
		{
			store_height();
		}
		
		if ((pieces[pos + distance[(dir + follower_l) & 3]] != 1) && (pieces[pos + 2 * distance[(dir + follower_l) & 3]] == 1))
		{
			spiralcounter++;
		}
		else
		{
			spiralcounter = 0;
		}			

		follow_repeat--;
		if (follow_repeat == 0)
		{
			follow_repeat = 1;
			// if ((totalsteps > 500) && (Math.random() < 0.25))
			if (trapitstartpos == -1)
			{
				if ((spiralcounter > 25))
				{
					follower_max_own = 0;
					own_steps = 0;
					dir = (dir + follower_r) & 3;
					trapitokcounter = 0;
					trapitstartpos = pos;
					onmessage = onmessage_trapit;
					do_move();
					return;
				}
			}
			dir = (dir + follower_l) & 3;
		}
		else
		{
			if (pieces[pos + distance[(dir + follower_l) & 3]] == 0)
			{
				pieces[pos + distance[(dir + follower_l) & 3]] = 3;
			}
		}

	}
	old_follower_state = dir;
	while (pieces[pos + distance[dir]] > allowed_pieces)
	{
		follow_dir_err[dir]++;
		follow_dir_err[(dir + 1) & 3] = 0;
		follow_dir_err[(dir + 2) & 3] = 0;
		follow_dir_err[(dir + 3) & 3] = 0;
		if (follow_dir_err[dir] > 1)
		{
			follow_repeat = follow_dir_err[dir] * 2;
			if (follow_repeat > 16) follow_repeat = 16;
		}
		else
		{
			follow_repeat = 1;
		}
		dir = (dir + follower_r) & 3;
		if (dir == old_follower_state)
		{
			if (finder())
			{
				onmessage = onmessage_walk_to_space;
			}
			else
			{
				onmessage = onmessage_do_rnd;
			}
			onmessage(theevent);
			return;
		}
	}
	do_move();
}

onmessage_straight = function(event)
{
	store_done(event);

	if (!done)
	{
		dir = (dir + follower_r) & 3;
		onmessage = onmessage_follower;
	}
	
	do_move();
}

onmessage_trapit = function (event)
{
	store_done(event);

	if (done)
	{	
		if (pos + 2 * distance[dir] == trapitstartpos)
		{
			onmessage = onmessage_filler;
			do_move();
			return;
		}
		
		if (pieces[pos + 2 * distance[(dir + follower_r) & 3]] == 0)
		{
			trapitokcounter++;
		}
		else
		{
			trapitokcounter = 0;
		}
		if (trapitokcounter > 1)
		{
			trapitokcounter = 0;
			dir = (dir + follower_r) & 3;
		}
		old_follower_state = dir;
	}
	else
	{
		onmessage = onmessage_follower;
		follower_r = (follower_r + 2) & 3;
		follower_l = (follower_l + 2) & 3;
		onmessage(event);
		return;
	}
	
	while (pieces[pos + 2 * distance[dir]] != 0)
	{
		trapitokcounter = 0;
		dir = (dir + follower_l) & 3;
		if (dir == old_follower_state)
		{
			if (finder())
			{
				onmessage = onmessage_walk_to_space;
			}
			else
			{
				onmessage = onmessage_do_rnd;
			}
			onmessage(theevent);
			return;
		}
	}

	do_move();
}

onmessage_filler = function (event)
{
	store_done(event);

	if (done)
	{
		dir = (dir + 3) & 3;
		old_follower_state = dir;
	}
	else
	{
		old_follower_state = dir;
		dir = (dir + 1) & 3;
	}
	
	while (pieces[pos + distance[dir]] != 0)
	{
		dir = (dir + 1) & 3;
		if (dir == old_follower_state)
		{
			if (finder())
			{
				onmessage = onmessage_walk_to_space;
			}
			else
			{
				onmessage = onmessage_do_rnd;
			}
			onmessage(theevent);
			return;
		}
	}

	do_move();
}

finder = function()
{

	lookup_read = 0;
	lookup_write = 0;
	feld_distance_done_val++;
	
	var fd = -1;
	
	feld_distance[pos] = fd;
	feld_distance_done[pos] = feld_distance_done_val;
	lookup_stack[lookup_write] = pos;
	lookup_write++;
	
	while (lookup_read < lookup_write)
	{
		actual_pos = lookup_stack[lookup_read];
		
		if
			(
				(pieces[actual_pos + distance[0]] == 0)
				||
				(pieces[actual_pos + distance[1]] == 0)
				||
				(pieces[actual_pos + distance[2]] == 0)
				||
				(pieces[actual_pos + distance[3]] == 0)
			)
		{
			break;					
		}
		
		fd--;
		
		for (var di = 0; di < 4; di++)
		{
			check_pos = actual_pos + distance[di];

			if (feld_distance_done[check_pos] != feld_distance_done_val)
			{
				if (pieces[check_pos] < 2)
				{
					feld_distance[check_pos] = fd;
					lookup_stack[lookup_write] = check_pos;
					lookup_write++;
				}
				else
				{
					feld_distance[check_pos] = -2000000;
				}
				feld_distance_done[check_pos] = feld_distance_done_val;
			}

			
		}

		lookup_read++;
	}
	
	if (lookup_read < lookup_write)
	{
		way_to_space_steps = 0;
		pos_for_space = lookup_stack[lookup_read];
		while (feld_distance[pos_for_space] != -1)
		{
			if (feld_distance_done[pos_for_space + distance[0]] != feld_distance_done_val)
			{
				feld_distance_done[pos_for_space + distance[0]] = feld_distance_done_val;
				feld_distance[pos_for_space + distance[0]] = -2000000;
			}
			if (feld_distance_done[pos_for_space + distance[1]] != feld_distance_done_val)
			{
				feld_distance_done[pos_for_space + distance[1]] = feld_distance_done_val;
				feld_distance[pos_for_space + distance[1]] = -2000000;
			}
			if (feld_distance_done[pos_for_space + distance[2]] != feld_distance_done_val)
			{
				feld_distance_done[pos_for_space + distance[2]] = feld_distance_done_val;
				feld_distance[pos_for_space + distance[2]] = -2000000;
			}
			if (feld_distance_done[pos_for_space + distance[3]] != feld_distance_done_val)
			{
				feld_distance_done[pos_for_space + distance[3]] = feld_distance_done_val;
				feld_distance[pos_for_space + distance[3]] = -2000000;
			}
			
			max_dist =
				Math.max
					(
						feld_distance[pos_for_space + distance[0]],
						feld_distance[pos_for_space + distance[1]],
						feld_distance[pos_for_space + distance[2]],
						feld_distance[pos_for_space + distance[3]]
					);
					
			if (feld_distance[pos_for_space + distance[0]] == max_dist)
			{
				pos_for_space = pos_for_space + distance[0];
				way_to_space[way_to_space_steps] = 2;
			}
			else
			{
				if (feld_distance[pos_for_space + distance[1]] == max_dist)
				{
					pos_for_space = pos_for_space + distance[1];
					way_to_space[way_to_space_steps] = 3;
				}
				else
				{
					if (feld_distance[pos_for_space + distance[2]] == max_dist)
					{
						pos_for_space = pos_for_space + distance[2];
						way_to_space[way_to_space_steps] = 0;
					}
					else
					{
						pos_for_space = pos_for_space + distance[3];
						way_to_space[way_to_space_steps] = 1;
					}
				}
			}
			way_to_space_steps++;
			
		}

		return true;
	}
	else
	{
		return false;
	}			
}

onmessage_walk_to_space = function(event)
{
	store_done(event);
	if (!done)
	{
		if (!finder())
		{
			onmessage = onmessage_do_rnd;
			onmessage(theevent);
			return;
		}
	}

	if (way_to_space_steps > 0)
	{
		way_to_space_steps--;
		dir = way_to_space[way_to_space_steps];
	}
	else
	{
		if (pieces[pos + distance[0]] == 0)
		{
			dir = 0;
		}
		else
		{
			if (pieces[pos + distance[1]] == 0)
			{
				dir = 1;
			}
			else
			{
				if (pieces[pos + distance[2]] == 0)
				{
					dir = 2;
				}
				else
				{
					dir = 3;
				}
			}
		}

		onmessage = onmessage_filler;
	}
	
	do_move();
}

onmessage_do_rnd = function(event)
{
	// postMessage({id: event.data.id,direction: dirs[dir], pieces: this.pieces});    
	postMessage({id: event.data.id,direction: dirs[dir]});    
	dir = Math.floor(Math.random() * 4);
}

onmessage = function (event) {
	theevent = event;
	pieces[new_pos] = 1;
	dir = 2;
	onmessage = onmessage_crosser;
	do_move();
}
